﻿Option Explicit On

Imports System.Math
Imports System.Text

Public Class Form1

    Private Const VB_CR As Byte = 13
    Private Const VB_LF As Byte = 10

    Private mWormupTime As Integer = 600
    Private IsMeasurering As Boolean = False
    Private IsWarmup As Boolean = False
    Private IsRecvWarmupFinish As Boolean = False

    Private mDataMark As Boolean = False
    Private mSeparated As Boolean = False

    Private mResponse As String = ""

    Private mPM2p5 As Double = 0
    Private mPM10 As Double = 0

    Private mTotalMilisec As Long = 0
    Private mTotalSecond As Long = 0

    Private mLogInterval As Integer = 0
    Private mAverage As Integer = 0

    Private mACC_PM2p5 As Double() = New Double(2) {}
    Private mACC_PM10 As Double() = New Double(2) {}
    Private mAccCount As Integer() = New Integer(2) {}
    Private mAccIndex As Integer = 0

    Private mAppPath As String = ""
    Private mHeadFlag As Boolean = False

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        Me.DoubleBuffered = True

        Me.Location = New Point(iPosition_X, iPosition_Y)

        lblElapsedTime.Visible = False
        lblWarmup.Visible = False
        lblPM2p5Mark.Visible = False
        lblPM2p5Value.Visible = False
        lblPM2p5Unit.Visible = False
        lblPM10Mark.Visible = False
        lblPM10Value.Visible = False
        lblPM10Unit.Visible = False

        mAppPath = System.Windows.Forms.Application.StartupPath
        If Not System.IO.Directory.Exists(mAppPath + "\Log\") Then
            System.IO.Directory.CreateDirectory(mAppPath + "\Log\")
        End If

    End Sub

    'フォームロード
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Select Case iAverage
            Case 0
                ComboBox1.SelectedIndex = 0
            Case 3
                ComboBox1.SelectedIndex = 1
            Case 5
                ComboBox1.SelectedIndex = 2
            Case 10
                ComboBox1.SelectedIndex = 3
            Case 30
                ComboBox1.SelectedIndex = 4
            Case 60
                ComboBox1.SelectedIndex = 5
        End Select

        Select Case iLogInterval
            Case 1
                ComboBox2.SelectedIndex = 0
            Case 10
                ComboBox2.SelectedIndex = 1
            Case 30
                ComboBox2.SelectedIndex = 2
            Case 60
                ComboBox2.SelectedIndex = 3
            Case 600
                ComboBox2.SelectedIndex = 4
            Case 1800
                ComboBox2.SelectedIndex = 5
            Case 3600
                ComboBox2.SelectedIndex = 6
        End Select

    End Sub

    'フォームクローズ
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing

        If SerialPort1.IsOpen Then
            e.Cancel = True
            Exit Sub
        End If

        If Timer1.Enabled Then
            Timer1.Enabled = False
        End If
        If Timer2.Enabled Then
            Timer2.Enabled = False
        End If

        My.Settings.Position_X = iPosition_X
        My.Settings.Position_Y = iPosition_Y
        My.Settings.LogInterval = iLogInterval
        My.Settings.Average = iAverage
        My.Settings.Save()

    End Sub

    Private Sub Form1_Move(sender As Object, e As EventArgs) Handles MyBase.Move

        iPosition_X = Me.Location.X
        iPosition_Y = Me.Location.Y

    End Sub

    '開始
    Private Sub btnON_Click(sender As Object, e As EventArgs) Handles btnON.Click

        btnON.Enabled = False
        btnON.BackColor = SystemColors.ControlDark
        btnOFF.Enabled = True
        btnOFF.BackColor = SystemColors.Control

        lblElapsedTime.Visible = False
        lblWarmup.Visible = False
        lblPM2p5Mark.Visible = False
        lblPM2p5Value.Visible = False
        lblPM2p5Unit.Visible = False
        lblPM10Mark.Visible = False
        lblPM10Value.Visible = False
        lblPM10Unit.Visible = False

        Try
            If SerialPort1.IsOpen Then
                SerialPort1.Close()
            End If
            SerialPort1.PortName = oSerialParam.PortName
            SerialPort1.BaudRate = oSerialParam.BaudRate
            Select Case oSerialParam.Parity
                Case "NONE"
                    SerialPort1.Parity = IO.Ports.Parity.None
                Case "ODD"
                    SerialPort1.Parity = IO.Ports.Parity.Odd
                Case "EVEN"
                    SerialPort1.Parity = IO.Ports.Parity.Even
            End Select
            Select Case oSerialParam.StopBits
                Case 1
                    SerialPort1.StopBits = IO.Ports.StopBits.One
                Case 1.5
                    SerialPort1.StopBits = IO.Ports.StopBits.OnePointFive
                Case 2
                    SerialPort1.StopBits = IO.Ports.StopBits.Two
            End Select
            SerialPort1.DataBits = oSerialParam.DataBits
            SerialPort1.Open()

        Catch ex As Exception
            Dim errMsg As String = ex.Message.ToString()
        End Try

        If Not SerialPort1.IsOpen Then
            btnON.Enabled = True
            btnON.BackColor = SystemColors.Control
            btnOFF.Enabled = False
            btnOFF.BackColor = SystemColors.ControlDark
            Exit Sub
        End If

        mACC_PM2p5(0) = 0
        mACC_PM2p5(1) = 0
        mACC_PM10(0) = 0
        mACC_PM10(1) = 0
        mAccCount(0) = 0
        mAccCount(1) = 0
        mAccIndex = 0

        SerialPort1.WriteLine("POWON" + vbCrLf)

        lblWarmup.Visible = True
        lblPM2p5Mark.Visible = False
        lblPM2p5Value.Visible = False
        lblPM2p5Unit.Visible = False
        lblPM10Mark.Visible = False
        lblPM10Value.Visible = False
        lblPM10Unit.Visible = False
        ComboBox1.Enabled = False
        ComboBox2.Enabled = False

        mWormupTime = 60 * 10
        IsWarmup = True
        IsMeasurering = False

        mTotalMilisec = 0

        Timer1.Interval = 100   '100ms
        Timer1.Enabled = True

    End Sub

    '停止
    Private Sub btnOFF_Click(sender As Object, e As EventArgs) Handles btnOFF.Click

        Timer1.Enabled = False
        Timer2.Enabled = False
        IsMeasurering = False

        If SerialPort1.IsOpen Then
            SerialPort1.WriteLine("STOP" + vbCrLf)
            Threading.Thread.Sleep(200)
            SerialPort1.WriteLine("POWOFF" + vbCrLf)
            Threading.Thread.Sleep(200)
            SerialPort1.Close()
        End If

        btnON.Enabled = True
        btnON.BackColor = SystemColors.Control
        btnOFF.Enabled = False
        btnOFF.BackColor = SystemColors.ControlDark

        lblWarmup.Visible = False
        lblPM2p5Mark.Visible = False
        lblPM2p5Value.Visible = False
        lblPM2p5Unit.Visible = False
        lblPM10Mark.Visible = False
        lblPM10Value.Visible = False
        lblPM10Unit.Visible = False
        lblElapsedTime.Visible = False
        ComboBox1.Enabled = True
        ComboBox2.Enabled = True

        Me.BackgroundImage = My.Resources.bg_blue   'BLUE

    End Sub

    Private monitorFlag = False

    '監視タイマー
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick

        If monitorFlag Then Exit Sub
        monitorFlag = True

        If IsWarmup Then

            lblWarmup.Visible = True
            lblPM2p5Mark.Visible = False
            lblPM2p5Value.Visible = False
            lblPM2p5Unit.Visible = False
            lblPM10Mark.Visible = False
            lblPM10Value.Visible = False
            lblPM10Unit.Visible = False

            If mWormupTime > 0 Then
                mWormupTime -= 1
            End If

            '時間監視でウォームアップ終了
            If mWormupTime <= 0 Then
                IsWarmup = False
                'InitAverageWork()
                SerialPort1.WriteLine("START" + vbCrLf)
                Threading.Thread.Sleep(200)
                IsMeasurering = True
                Timer2.Interval = 1000   '1s
                Timer2.Enabled = True
                lblElapsedTime.Visible = True
                'RecordingOn();
            End If

            'センサーからの通知でウォームアップ終了
            If IsRecvWarmupFinish Then
                IsWarmup = False
                IsRecvWarmupFinish = False
                'InitAverageWork()
                SerialPort1.WriteLine("START" + vbCrLf)
                Threading.Thread.Sleep(200)
                IsMeasurering = True
                Timer2.Interval = 1000   '1s
                Timer2.Enabled = True
                lblElapsedTime.Visible = True
                'RecordingOn();
            End If

        Else
            Dim color_score As Integer = 1
            Dim color_score1 As Integer = 0
            Dim color_score2 As Integer = 0

            If IsMeasurering Then

                lblWarmup.Visible = False
                lblPM2p5Mark.Visible = True
                lblPM2p5Value.Visible = True
                lblPM2p5Unit.Visible = True
                lblPM10Mark.Visible = True
                lblPM10Value.Visible = True
                lblPM10Unit.Visible = True

                'PM2.5
                If mPM2p5 < 15.5 Then
                    color_score1 = 1    'BLUE
                ElseIf mPM2p5 < 40.5 Then
                    color_score1 = 2    'YELLOW
                ElseIf mPM2p5 < 65.5 Then
                    color_score1 = 3    'ORANGE
                ElseIf mPM2p5 < 150.5 Then
                    color_score1 = 4    'RED
                ElseIf mPM2p5 < 250.5 Then
                    color_score1 = 5    'PURPLE
                Else
                    color_score1 = 6    'BLACK
                End If
                'PM10
                If mPM10 < 15.5 Then
                    color_score2 = 1    'BLUE
                ElseIf mPM10 < 40.5 Then
                    color_score2 = 2    'YELLOW
                ElseIf mPM10 < 65.5 Then
                    color_score2 = 3    'ORANGE
                ElseIf mPM10 < 150.5 Then
                    color_score2 = 4    'RED
                ElseIf mPM10 < 250.5 Then
                    color_score2 = 5    'PURPLE
                Else
                    color_score2 = 6    'BLACK
                End If

                If color_score1 >= color_score2 Then
                    color_score = color_score1
                Else
                    color_score = color_score2
                End If

                lblPM2p5Value.Text = mPM2p5.ToString("0.0")
                lblPM10Value.Text = mPM10.ToString("0.0")

            End If

            If color_score = 1 Then
                Me.BackgroundImage = My.Resources.bg_blue   'BLUE
            ElseIf color_score = 2 Then
                Me.BackgroundImage = My.Resources.bg_yellow 'YELLOW
            ElseIf color_score = 3 Then
                Me.BackgroundImage = My.Resources.bg_orange 'ORANGE
            ElseIf color_score = 4 Then
                Me.BackgroundImage = My.Resources.bg_red    'RED
            ElseIf color_score = 5 Then
                Me.BackgroundImage = My.Resources.bg_purple 'PURPLE
            Else
                Me.BackgroundImage = My.Resources.bg_black  'BLACK
            End If

        End If

        monitorFlag = False

    End Sub

    '経過タイマー
    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick

        If Not IsMeasurering Then Exit Sub

        mTotalMilisec += 1000

        If mTotalMilisec > 0 Then
            mTotalSecond = Math.Ceiling(CType(mTotalMilisec, Double) / 1000.0 * 100.0) / 100.0

            Dim sec As Double = mTotalSecond
            Dim hh As Integer = Math.Truncate(sec / 3600)
            sec = sec - hh * 3600
            Dim mm As Integer = Math.Truncate(sec / 60)
            Dim ss As Integer = sec - mm * 60

            lblElapsedTime.Text = Format(hh, "00") + ":" + Format(mm, "00") + ":" + Format(ss, "00")

        End If

        '平均
        Dim i As Integer
        If iAverage > 0 Then
            mAverage -= 1
            If mAverage < 1 Then

                mAverage = iAverage

                i = mAccIndex
                If mAccIndex = 0 Then
                    mAccIndex = 1
                Else
                    mAccIndex = 0
                End If

                If mAccCount(i) > 0 Then
                    mPM2p5 = mACC_PM2p5(i) / mAccCount(i)
                    mPM10 = mACC_PM10(i) / mAccCount(i)
                End If
            End If
        End If


        'ログ出力
        Dim f As Boolean = False
        If iLogInterval > 1 Then
            mLogInterval -= 1
            If mLogInterval < 1 Then
                mLogInterval = iLogInterval
                f = True
            End If
        Else
            f = True
        End If
        If f Then
            Dim fileName As String = mAppPath + "\Log\pmlog.csv"
            Dim sw As System.IO.StreamWriter = Nothing
            Try
                sw = New System.IO.StreamWriter(fileName, True, System.Text.Encoding.GetEncoding("shift_jis"))
                If Not mHeadFlag Then
                    mHeadFlag = True
                    sw.WriteLine("DATE,TIME,Latitude,Longitude,PM2.5(μg/m3),PM10(μg/m3)")
                End If
                Dim body As String = ""
                body += Date.Now.ToString("yyyy/MM/dd")
                body += ","
                body += Date.Now.ToString("HH:mm:ss")
                body += ","
                body += ","
                body += ","
                body += mPM2p5.ToString("0.0")
                body += ","
                body += mPM10.ToString("0.0")
                sw.WriteLine(body)
                sw.Close()

            Catch ex As Exception
                If Not sw Is Nothing Then
                    sw.Close()
                End If
            End Try

        End If

    End Sub

    'シリアルポート・データ受信
    Private Sub SerialPort1_DataReceived(sender As Object, e As IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        Dim rbuf As Byte() = New Byte(SerialPort1.BytesToRead - 1) {}
        SerialPort1.Read(rbuf, 0, rbuf.GetLength(0))

        For i As Integer = 0 To rbuf.Length - 1

            If Encoding.UTF8.GetString(rbuf, i, 1) = ">" Then
                mDataMark = True
            Else
                If rbuf(i) <> VB_CR Then
                    If rbuf(i) = VB_LF Then
                        RecvResponse(mResponse, mDataMark)
                        mResponse = ""
                        mDataMark = False
                    Else
                        mResponse += Encoding.UTF8.GetString(rbuf, i, 1)
                    End If
                End If
            End If
        Next
    End Sub

    '受信データ判定
    Private Sub RecvResponse(response As String, dataMark As Boolean)

        Try
            If dataMark Then
                'データレスポンス
                'PM2.5=0000,PM10=0000
                If response.IndexOf("PM2.5") >= 0 And response.IndexOf(",PM10") > 0 Then
                    Dim aPM As String() = Split(response, ",")
                    Dim aPM2p5 As String() = Split(aPM(0), "=")
                    Dim aPM10 As String() = Split(aPM(1), "=")

                    Dim pm2p5 As Double = Double.Parse(aPM2p5(1).Trim()) / 10
                    Dim pm10 As Double = Double.Parse(aPM10(1).Trim()) / 10

                    If iAverage = 0 Then
                        mPM2p5 = pm2p5
                        mPM10 = pm10
                    Else
                        mACC_PM2p5(mAccIndex) += pm2p5
                        mACC_PM10(mAccIndex) += pm10
                        mAccCount(mAccIndex) += 1
                    End If

                ElseIf response.IndexOf("FINISH WARM") >= 0 Then
                    IsRecvWarmupFinish = True
                End If
            Else
                'コマンドレスポンス
                If response.IndexOf("OK") >= 0 Then
                ElseIf response.IndexOf("NG") >= 0 Then
                End If
            End If

        Catch ex As Exception
        End Try

    End Sub

    'ログ間隔
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox2.SelectedIndexChanged

        Select Case ComboBox2.SelectedIndex
            Case 0
                iLogInterval = 1
            Case 1
                iLogInterval = 10
            Case 2
                iLogInterval = 30
            Case 3
                iLogInterval = 60
            Case 4
                iLogInterval = 600
            Case 5
                iLogInterval = 1800
            Case 6
                iLogInterval = 3600
        End Select

    End Sub

    '平均
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged

        Select Case ComboBox1.SelectedIndex
            Case 0
                iAverage = 0
            Case 1
                iAverage = 3
            Case 2
                iAverage = 5
            Case 3
                iAverage = 10
            Case 4
                iAverage = 30
            Case 5
                iAverage = 60
        End Select

    End Sub

    Private Sub 終了XToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 終了XToolStripMenuItem.Click

        If Not SerialPort1.IsOpen Then
            Threading.Thread.Sleep(200)
            Me.Close()
        End If

    End Sub

    Private Sub 通信ポートPToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 通信ポートPToolStripMenuItem.Click

        If SerialPort1.IsOpen Then Exit Sub

        bCancel = True
        oForm2 = New Form2
        oForm2.ShowDialog()

        If Not bCancel Then
            oSerialParam.PortName = My.Settings.PortName
            oSerialParam.BaudRate = My.Settings.BaudRate
            oSerialParam.Parity = My.Settings.Parity
            oSerialParam.StopBits = My.Settings.StopBits
            oSerialParam.DataBits = My.Settings.DataBits
        End If

    End Sub

End Class
